
class PersonController {
    @Property index = { redirect(action:list,params:params) }

    @Property list = {
        if(!params['max']) params['max'] = 10
        [ personList: Person.list( params ) ]
    }

    @Property show = {
        [ person : Person.get( params['id'] ) ]
    }

    @Property delete = {
        def person = Person.get( params['id'] )
        if(person) {
            person.delete()
            flash['message'] = "Person ${params['id']} deleted."
            redirect(action:list)
        }
        else {
            flash['message'] = "Person not found with id ${params['id']}"
            redirect(action:list)
        }
    }

    @Property edit = {
        def person = Person.get( params['id'] )

        if(!person) {
                flash['message'] = "Person not found with id ${params['id']}"
                redirect(action:list)
        }
        else {
            return [ person : person ]
        }
    }

    @Property update = {
        def person = Person.get( params['id'] )
        if(person) {
             person.properties = params
            if(person.save()) {
                redirect(action:show,id:person.id)
            }
            else {
                render(view:'edit',model:[person:person])
            }
        }
        else {
            flash['message'] = "Person not found with id ${params['id']}"
            redirect(action:edit,id:params['id'])
        }
    }

    @Property create = {
        def person = new Person()
        person.properties = params
        return ['person':person]
    }

    @Property save = {
        def person = new Person()
        person.properties = params
        if(person.save()) {
            redirect(action:show,id:person.id)
        }
        else {
            render(view:'create',model:[person:person])
        }
    }

    @Property saveperson = {
        def person = new Person()
        person.properties = params
        if(person.save()) {
			return [ personList: Person.list( params ) ]
        }
        else {
            render(view:'create',model:[person:person])
        }
    }
}