
class StateController {
    @Property index = { redirect(action:list,params:params) }

    @Property list = {
        if(!params['max']) params['max'] = 10
        [ stateList: State.list( params ) ]
    }

    @Property show = {
        [ state : State.get( params['id'] ) ]
    }

    @Property delete = {
        def state = State.get( params['id'] )
        if(state) {
            state.delete()
            flash['message'] = "State ${params['id']} deleted."
            redirect(action:list)
        }
        else {
            flash['message'] = "State not found with id ${params['id']}"
            redirect(action:list)
        }
    }

    @Property edit = {
        def state = State.get( params['id'] )

        if(!state) {
                flash['message'] = "State not found with id ${params['id']}"
                redirect(action:list)
        }
        else {
            return [ state : state ]
        }
    }

    @Property update = {
        def state = State.get( params['id'] )
        if(state) {
             state.properties = params
            if(state.save()) {
                redirect(action:show,id:state.id)
            }
            else {
                render(view:'edit',model:[state:state])
            }
        }
        else {
            flash['message'] = "State not found with id ${params['id']}"
            redirect(action:edit,id:params['id'])
        }
    }

    @Property create = {
        def state = new State()
        state.properties = params
        return ['state':state]
    }

    @Property save = {
        def state = new State()
        state.properties = params
        if(state.save()) {
            redirect(action:show,id:state.id)
        }
        else {
            render(view:'create',model:[state:state])
        }
    }

}